
import pnuts.lang.*;
import com.ibm.math.BigDecimal;

/**
 * BigDecimal by IBM ( http://www.alphaWorks.ibm.com/formula/bigdecimal/ )
 */
public class Decimal extends Number implements Numeric, Comparable {

    public static void init(){
	Pnuts.registerQuantityFactory("b", new QuantityFactory(){
	    public Object make(Number n, String unit){
		return new Decimal(new BigDecimal("" + n));
	    }
	});
    }

    BigDecimal d;

    public Decimal(BigDecimal d){
	this.d = d;
    }

    public Object add(Object obj){
	if (obj instanceof Decimal){
	    return new Decimal(d.add(((Decimal)obj).d));
	} else {
	    return new Decimal(d.add(new BigDecimal("" + obj)));
	}
    }

    public Object subtract(Object obj){
	if (obj instanceof Decimal){
	    return new Decimal(d.subtract(((Decimal)obj).d));
	} else {
	    return new Decimal(d.subtract(new BigDecimal("" + obj)));
	}
    }

    public Object multiply(Object obj){
	if (obj instanceof Decimal){
	    return new Decimal(d.multiply(((Decimal)obj).d));
	} else {
	    return new Decimal(d.multiply(new BigDecimal("" + obj)));
	}
    }

    public Object divide(Object obj){
	if (obj instanceof Decimal){
	    return new Decimal(d.divide(((Decimal)obj).d, null));
	} else {
	    return new Decimal(d.divide(new BigDecimal("" + obj), null));
	}
    }

    public Object negate(){
	return new Decimal(d.negate());
    }

    public Object inverse(){
	return new Decimal(new BigDecimal(1).divide(d));
    }

    public int compareTo(Object obj){
	if (obj instanceof Decimal){
	    return d.compareTo(((Decimal)obj).d);
	} else {
	    return d.compareTo(obj);
	}
    }

    public int intValue(){
	return d.intValue();
    }

    public long longValue(){
	return d.longValue();
    }

    public float floatValue(){
	return d.floatValue();
    }

    public double doubleValue(){
	return d.doubleValue();
    }
 
    public byte byteValue(){
	return d.byteValue();
    }
 
    public short shortValue(){
	return d.shortValue();
    }
 
    public String toString(){
	return d.toString();
    }

    public BigDecimal getBigDecimal(){
	return d;
    }
}
