
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import pnuts.awt.PnutsLayout;
import pnuts.awt.Layout;

public class PnutsLayoutEditor extends Dialog implements ActionListener, ItemListener {
    Container parent;
    PnutsLayout lm;
    Component comp;
    PnutsLayoutFrame demo;

    public PnutsLayoutEditor(PnutsLayoutFrame demo, Component c){
	super(demo, c.getName());
	this.comp = c;
	this.demo = demo;
	init();
    }

    TextField t2 = new TextField(10);
    TextField t3 = new TextField(10);
    TextField t4 = new TextField(10);
    TextField t5 = new TextField(10);
    TextField t6 = new TextField(10);
    TextField t7 = new TextField(10);
	{
	    t2.addActionListener(this);
	    t3.addActionListener(this);
	    t4.addActionListener(this);
	    t5.addActionListener(this);
	    t6.addActionListener(this);
	    t7.addActionListener(this);
	}
    Button ok = new Button("Apply");
    Button cancel = new Button("Close");
    Choice ch1 = choice(new String[]{"Left", "Right", "Center", "Fill"});
    Choice ch2 = choice(new String[]{"Top", "Bottom", "Center", "Fill"});
    Choice ch3 = choice(new String[]{"Don't Expand", "X", "Y", "XY"});

    static Choice choice(String s[]){
	return PnutsLayoutFrame.choice(s);
    }

    void init(){
	parent = comp.getParent();
	lm = (PnutsLayout)parent.getLayout();
	add(Layout.layout(new Object[]{
	    PnutsLayout.class, "cols=3, pady=2,halign=right",
		  "halign",
		  new Object[]{ch1, "colspan=2"},
		  "valign",
		  new Object[]{ch2, "colspan=2"},
		  "expand",
		  new Object[]{ch3, "colspan=2"},
		  "colspan",
		  new Object[]{t2, "colspan=2"},
		  "rowspan",
		  new Object[]{t3, "colspan=2"},
		  "padx",
		  new Object[]{t4, "colspan=2"},
		  "pady",
		  new Object[]{t5, "colspan=2"},
		  "ipadx",
		  new Object[]{t6, "colspan=2"},
		  "ipady",
		  new Object[]{t7, "colspan=2"},
		  null,
		  new Object[]{ok, "padx=10, pady=10"},
		  new Object[]{cancel, "padx=10, pady=10"}
	}), "Center");
	ok.addActionListener(this);
	cancel.addActionListener(this);

	Hashtable t = lm.getConstraints(comp);
	String halign = (String)t.get("halign");
	int idx = 0;
	if ("fill".equals(halign)){
	    idx = 3;
	} else if ("right".equals(halign)){
	    idx = 1;
	} else if ("left".equals(halign)){
	    idx = 0;
	} else {
	    idx = 2;
	}
	ch1.select(idx);

	String valign = (String)t.get("valign");
	if ("fill".equals(valign)){
	    idx = 3;
	} else if ("bottom".equals(valign)){
	    idx = 1;
	} else if ("top".equals(valign)){
	    idx = 0;
	} else {
	    idx = 2;
	}
	ch2.select(idx);

	String expand = (String)t.get("expand");
	if ("xy".equals(expand)){
	    idx = 3;
	} else if ("y".equals(expand)){
	    idx = 2;
	} else if ("x".equals(expand)){
	    idx = 1;
	} else {
	    idx = 0;
	}
	ch3.select(idx);

	t2.setText("" + lm.getColspan(comp));
	t3.setText("" + lm.getRowspan(comp));
	int padx = lm.getPadX(comp);
	int pady = lm.getPadY(comp);
	t4.setText("" + padx);
	t5.setText("" + pady);
	int ipadx = lm.getIPadX(comp);
	int ipady = lm.getIPadY(comp);
	t6.setText("" + ipadx);
	t7.setText("" + ipady);

	ch1.addItemListener(this);
	pack();
    }

    public void itemStateChanged(ItemEvent e){
	Choice c = (Choice)e.getSource();
	if (c == ch1){
	    if (ch1.getSelectedIndex() >= 3){ // expand
		t4.setEditable(true); // padx
		t6.setEditable(false); //ipadx
	    } else if (ch1.getSelectedIndex() == 2){ // center
		t4.setEditable(false);
		t6.setEditable(true);
	    } else { // left or right
		t4.setEditable(true);
		t6.setEditable(true);
	    }
	} else if (c == ch2){
	    if (ch2.getSelectedIndex() >= 3){ // fill
		t5.setEditable(true);  // pady
		t7.setEditable(false); // ipady
	    } else if (ch2.getSelectedIndex() == 2){ // center
		t5.setEditable(false);
		t7.setEditable(true);
	    } else { // left or right
		t5.setEditable(true);
		t7.setEditable(true);
	    }
	}
    }

    void apply(){
	String constraints = "";
	constraints += "halign=" + ch1.getSelectedItem();
	constraints += ",valign=" + ch2.getSelectedItem();
	int idx = ch3.getSelectedIndex();
	switch (idx){
	case 0: break;
	case 1: constraints += ",expand=x"; break;
	case 2: constraints += ",expand=y"; break;
	case 3: constraints += ",expand=xy"; break;
	}
	constraints += ",colspan=" + t2.getText();
	constraints += ",rowspan=" + t3.getText();
	constraints += ",padx=" + t4.getText();
	constraints += ",pady=" + t5.getText();
	constraints += ",ipadx=" + t6.getText();
	constraints += ",ipady=" + t7.getText();
	lm.setConstraints(comp, constraints);
	comp.invalidate();
	demo.validate();
	demo.update();
    }

    public void actionPerformed(ActionEvent e){
	Object source = e.getSource();
	if (source == ok ||
	    source == t2 ||
	    source == t3 ||
	    source == t4 ||
	    source == t5 ||
	    source == t6 ||
	    source == t7){
	    apply();
	} else if (source == cancel){
	    dispose();
	}
    }
}
