
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import pnuts.awt.PnutsLayout;
import pnuts.awt.Layout;

public class PnutsLayoutFrame extends Frame implements WindowListener, ItemListener, ActionListener, MouseListener {

    public PnutsLayoutFrame(){
	super("PnutsLayout Demo");
	init();
    }

    static Choice choice(String[] s){
	Choice ch = new Choice();
	for (int i = 0; i < s.length; i++){
	    ch.add(s[i]);
	}
	return ch;
    }

    Button b1 = new Button("Edit");
	{
	    b1.addActionListener(this);
	}
    Button b2 = new Button("Edit");
	{
	    b2.addActionListener(this);
	}
    TextField tf = new TextField(5);
    Choice ch0 = choice(new String[]{"none", "x", "y", "xy"});
	{
	    ch0.addItemListener(this);
	}
    Hashtable dialogs = new Hashtable();
    int counter = 0;
    Cursor waitCursor = Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);
    Cursor defaultCursor = Cursor.getDefaultCursor();
    MenuItem add = new MenuItem("Add");
	{
	    add.addActionListener(this);
	}
    MenuItem delete = new MenuItem("Delete");
	{
	    delete.addActionListener(this);
	}
    MenuItem inspect = new MenuItem("Show Inspector");
	{
	    inspect.addActionListener(this);
	}
    Dialog inspector;

    void init(){
	MenuBar mbar = new MenuBar();
	Menu m1 = new Menu("File");
	m1.add(add);
	m1.add(delete);
	m1.add(inspect);
	mbar.add(m1);
	setMenuBar(mbar);
	setSize(400, 300);
	add(Layout.layout(new Panel(),
			  new Object[]{BorderLayout.class,
				       new Object[]{},
				       new Object[]{ "North", new Object[]{
					   PnutsLayout.class, "cols=4",
					   "cols=",
					   new Object[]{tf, "padx=10"},
					   "uniform=",
					   ch0}},
				       new Object[]{ "Center", new Object[]{
					   PnutsLayout.class, "cols=2",
					   b1, b2}
				       }
	                    }), "Center");
	addWindowListener(this);
	tf.setText("" + ((PnutsLayout)b1.getParent().getLayout()).getCols());
	tf.addActionListener(this);
	b1.setName("Button" + ++counter);
	b2.setName("Button" + ++counter);
	b1.setLabel(b1.getName());
	b2.setLabel(b2.getName());
	b1.getParent().setBackground(Color.decode("#e2e2e2"));
	show();
    }

    public void windowClosing(WindowEvent e){
	dispose();
    }

    public void windowOpened(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}

    public void itemStateChanged(ItemEvent e){
	String item = ch0.getSelectedItem();
        PnutsLayout lm = (PnutsLayout)b1.getParent().getLayout();
	lm.setUniform(item.indexOf("x") >= 0, item.indexOf("y") >= 0);
	b1.getParent().invalidate();
	b1.getParent().validate();
	b1.getParent().repaint();
    }

    void edit(Component comp){
	Dialog d = null;
	if ((d = (Dialog)dialogs.get(comp)) != null){
	    d.setVisible(true);
	    d.toFront();
	    return;
	} else {
	    PnutsLayoutEditor e = new PnutsLayoutEditor(this, comp);
	    dialogs.put(comp, e);
	    e.show();
	}
    }

    void flip(){
	if (inspector == null) return;
	if (inspector.isVisible()){
	    inspect.setLabel("Show Inspector");
	    inspector.setVisible(false);
	} else {
	    inspect.setLabel("Hide Inspector");
	    inspector.setVisible(true);
	}
    }

    TextArea ta = new TextArea();

    void update(){
	if (inspector != null && inspector.isVisible()){
	    inspect();
	}
    }

    void inspect(){
	if (inspector == null){
	    inspector = new Dialog(this, "Inspector");
	    ta.setEditable(false);
	    inspector.add(ta, "Center");
	    inspector.setSize(400, 200);
	    inspector.show();
	    inspect.setLabel("Hide Inspector");
	}
	Container parent = b1.getParent();
	PnutsLayout lm = (PnutsLayout)parent.getLayout();
	String buf = "";
	for (int i = 0; i < parent.getComponentCount(); i++){
	    Component c = parent.getComponent(i);
	    buf += "add(" + c.getName() + ",\"";
	    buf += lm.getConstraintString(c);
	    buf += "\")\n";
	}
	ta.setText(buf);
    }

    public void actionPerformed(ActionEvent ev){
	Object comp = ev.getSource();
	if (comp == add){
	    Button b = new Button("Edit");
	    b.setName("Button" + ++counter);
	    b.setLabel(b.getName());
	    Container parent = b1.getParent();
	    parent.add(b, new Hashtable());
	    validate();
	    if (inspector != null) inspect();
	    b.addMouseListener(this);
	    tf.requestFocus();
	} else if (comp == delete){
	    Container parent = b1.getParent();
	    Component c = parent.getComponent(parent.getComponentCount() - 1);
	    parent.remove(c);
	    validate();
	    if (inspector != null) inspect();
	} else if (comp == tf){
	    PnutsLayout lm = (PnutsLayout)b1.getParent().getLayout();
	    lm.setCols(Integer.parseInt(tf.getText()));
	    tf.setText("" + lm.getCols());
	    b1.getParent().invalidate();
	    validate();
	    tf.requestFocus();
	} else if (comp == inspect){
	    flip();
	    inspect();
	} else {
	    edit((Component)comp);
	}
    }

    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    public void mousePressed(MouseEvent e){}
    public void mouseClicked(MouseEvent e){}
    public void mouseReleased(MouseEvent e){
	edit((Component)e.getSource());
    }
}
