
import pnuts.lang.Property;
import java.beans.Introspector;
import java.beans.BeanInfo;
import java.beans.PropertyDescriptor;
import java.beans.IntrospectionException;
import java.util.Hashtable;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;

public class BeansProperty implements Property {
    Hashtable reader = new Hashtable();
    Hashtable writer = new Hashtable();
    Object bean;

    public BeansProperty(Object bean){
	this.bean = bean;
	Class clazz = bean.getClass();
	try{
	    BeanInfo info = Introspector.getBeanInfo(clazz);
	    PropertyDescriptor properties[] = info.getPropertyDescriptors();
	    for (int i = 0; i < properties.length; i++){
		String name = properties[i].getName();
		Method getter = properties[i].getReadMethod();
		Method setter = properties[i].getWriteMethod();
		if (getter != null){
		    reader.put(name, getter);
		}
		if (setter != null){
		    writer.put(name, setter);
		}
	    }
	} catch (IntrospectionException e){
	    e.printStackTrace();
	}
    }

    public Object get(String name){
	try {
	    Method getter = (Method)reader.get(name);
	    return getter.invoke(bean, new Object[]{});
	} catch (Exception e){
	    throw new RuntimeException("error in getter method: " + name);
	}
    }

    public void set(String name, Object value){
	try {
	    Method setter = (Method)writer.get(name);
	    setter.invoke(bean, new Object[]{value});
	} catch (Exception e){
	    throw new RuntimeException("error in setter method: " + name);
	}
    }

    public Object getBeans(){
	return bean;
    }
}
