
import pnuts.lang.Property;
import java.util.Hashtable;

/**
 * ro = ControledProperty()
 * ro.foo = 100
 * ro.bar = 200
 * ro.baz = 300
 * ro.setReadOnly("foo")
 *
 * ro.foo       ==> 100
 * ro.foo = 200 ==> throw RuntimeException
 */
public class ControledProperty implements Property {
    Hashtable tab = new Hashtable();
    Hashtable readonly = new Hashtable();

    public void setReadOnly(String name){
	readonly.put(name, Boolean.TRUE);
    }

    public void set(String name, Object value){
	if (readonly.get(name) != null){
	    throw new RuntimeException("read only");
	} else {
	    tab.put(name, value);
	}
    }

    public Object get(String name){
	return tab.get(name);
    }
}
