
import java.io.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import pnuts.lang.*;

public class PnutsSecurityManager extends SecurityManager {

    public PnutsSecurityManager(){ }

    void check(){
	if (!PnutsServer.initialized()){
	    return;
	}
    	if (Pnuts.evalDepth() > 0){
	    throw new SecurityException();
	}
    }
    
    void dump(){
	System.out.println("eval:" + Pnuts.evalDepth());
    }

    public void checkExit(int status) {
	check();
    }
    public void checkExec(String cmd) {
	check();
    }

    public void checkWrite(FileDescriptor fd) {
	check();
    }
    public void checkWrite(String file) {
	check();
    }
    public void checkDelete(String file) {
	check();
    }
    public void checkPropertyAccess(String key) {
	if (!PnutsServer.initialized()){
	    return;
	}
	if (Pnuts.evalDepth() > 0){
	    if ("user.home".equals(key)){
		throw new SecurityException();
	    }
	}
    }
    public void checkPropertyAccess(String key, String def) {
	check();
    }

    public void checkLink(String lib) { }

    public void checkRead(FileDescriptor fd) {  }
    public void checkRead(String file) {
	if (!PnutsServer.initialized()){
	    return;
	}
	if (Pnuts.evalDepth() > 0){
	    if (!file.endsWith(".pnut")){
		throw new SecurityException();
	    }
	}
    }
    public void checkRead(String file, Object context) {
	if (!PnutsServer.initialized()){
	    return;
	}
	if (Pnuts.evalDepth() > 0){
	    if (!file.endsWith(".pnut")){
		throw new SecurityException();
	    }
	}
    }

    public void checkCreateClassLoader() { } 

    public void checkAccess(Thread g) {
	check();
    }

    public void checkAccess(ThreadGroup g) {
	check();
    }

    public void checkConnect(String host, int port) { }
    public void checkConnect(String host, int port, Object context) { }
    public void checkListen(int port) { }
    public void checkAccept(String host, int port) { }
    public void checkMulticast(InetAddress maddr) { }
    public void checkMulticast(InetAddress maddr, byte ttl) { }
    public void checkPropertiesAccess() { }

    public boolean checkTopLevelWindow(Object window) { return true; }
    public void checkPrintJobAccess() { }
    public void checkSystemClipboardAccess() { }
    public void checkAwtEventQueueAccess() { }
    public void checkPackageAccess(String pkg) { 
	if (!PnutsServer.initialized()){
	    return;
	}
   	if (Pnuts.evalDepth() > 0){
	    if (pkg.startsWith("java.awt")){
		throw new SecurityException();
	    }
	}
    }
    public void checkPackageDefinition(String pkg) { }
    public void checkSetFactory() { }
    public void checkMemberAccess(Class clazz, int which) { }
    public void checkSecurityAccess(String provider) { }
}
