
import java.net.*;
import java.io.*;
import java.util.*;
import pnuts.lang.*;

public class PnutsServer implements Runnable {
    ServerSocket ss;
    static Hashtable table = new Hashtable();

    static {
	System.setSecurityManager(new PnutsSecurityManager());
    }

    public PnutsServer(int port) throws IOException {
	ss = new ServerSocket(port);
    }

    public static boolean initialized(){
	return table.get(Thread.currentThread()) != null;
    }

    public void initialize(){
	if (!initialized()){
	    table.put(Thread.currentThread(), Boolean.TRUE);
	}
    }

    public void run(){
	while (true){
	    try {
		Socket s = ss.accept();
		DataInputStream in = new DataInputStream(s.getInputStream());
		OutputStream out = s.getOutputStream();

		Context context = new Context();
		context.setOutputStream(out);
		context.setErrorStream(out);
		context.setTerminalStream(out);
		Pnuts.load("init.pnut", context);
		initialize();
		Pnuts.load(in, true, context);
		out.close();
		break;
	    } catch (IOException e){
		e.printStackTrace();
	    }
	}
    }

    public static void main(String args[]){
	try {
	    PnutsServer s = new PnutsServer(8888);
 	    new Thread(s).start();
 	    new Thread(s).start();
 	    new Thread(s).start();
 	    new Thread(s).start();
	} catch (Exception e){
	    e.printStackTrace();
	}
    }
}
