/*
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
import java.awt.*;
import pnuts.awt.*;
import com.sun.java.swing.*;

/**
 * JTabbedPane mapping of <a href="/pnuts/doc/hierarchicalLayout.html">Hierarchical Layout</a>.
 *
 * Layout.registerLayoutMapping(JTabbedPane.class, JTabbedPaneMapping.class);
 *
 * layout(container, [JTabbedPane, position, [component, title, icon, tip], ...])
 *
 * <a href="tab.pnut">sample</a>.
 *
 * @version	%I%
 * @author	Toyokazu Tomatsu
 */
public class JTabbedPaneMapping extends Layout {

    public Container createContainer(Container container, Object[] format){
	Object args = format[1];
	JTabbedPane pane = null;
	if (args instanceof Number){
	    pane = new JTabbedPane(((Integer)args).intValue());
	} else {
	    pane = new JTabbedPane();
	}
	container.setLayout(new BorderLayout());
	for (int i = 2; i < format.length; i++){
	    Object[] a = (Object[])format[i];
	    Component component = null;
	    if (a[0].getClass().isArray()){
		component = Layout.layout(makePanel(container), (Object[])a[0]);
	    } else if (a[0] instanceof Component){
		component = (Component)a[0];
	    }

	    String title = null;
	    Icon icon = null;
	    String tip = null;

	    if (a.length > 1){
		title = (String)a[1];
		if (a.length > 2){
		    icon = (Icon)a[2];
		    if (a.length > 3){
			tip = (String)a[3];
		    }
		}
	    }

	    if (a.length == 4){
		pane.addTab(title, icon, component, tip);
	    } else if (a.length == 3){
		pane.addTab(title, icon, component);
	    } else if (a.length == 2){
		pane.addTab(title, component);
	    } else if (component != null){
		pane.add(component);
	    }
	}
	container.add("Center", pane);
	return container;
    }
}
