/*
 * %Z% %M%	%I% %E%
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.ole;

import pnuts.lang.AbstractData;
import pnuts.lang.PnutsException;
import pnuts.lang.Runtime;

/**
 * Cast an object to the specified class
 */
public class Cast implements AbstractData {
    Object target;
    Class type;

    public Cast(Object target, Class type){
	this.target = target;
	this.type = type;
    }

    public Object get(String name){
	try {
	    return type.getField(name).get(target);
	} catch (Exception e){
	    throw new PnutsException(e);
	}
    }

    public void set(String name, Object value){
	try {
	    type.getField(name).set(target, value);
	} catch (Exception e){
	    throw new PnutsException(e);
	}
    }

    public Object invoke(String name, Object[] args){
	try {
	    return Runtime.callMethod(type, name, args, target);
	} catch (Exception e){
	    throw new PnutsException(e);
	}
    }

    public Object getTarget(){
	return target;
    }

    public Class getType(){
	return type;
    }
}
