/*
 * @(#) ComDispatch.java	1.2 99/03/30
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.ole;

import pnuts.lang.AbstractData;
import com.ms.com.*;

public class ComDispatch implements AbstractData {
    Object disp = null;

    public ComDispatch(){}

    public ComDispatch(Object disp){
	this.disp = disp;
    }

    public void set(String name, Object value){
        Dispatch.put(disp, name, value);
    }

    public Object get(String name){
	Object o = Dispatch.get(disp, name);
	if (o instanceof Variant){
	    return ComObject.getVariantValue((Variant)o);
	} else {
	    return o;
	}
    }

    static Variant[] makearray(Object[] a){
	Variant v[] = new Variant[a.length];
	for (int i = 0; i < a.length; i++){
	    Object o = a[i];
	    if (o == null){
		v[i] = new Variant();
	    } else if (o instanceof Variant){
		v[i] = (Variant)o;
	    } else if (o instanceof Integer){
		v[i] = new Variant(((Integer)o).intValue());
	    } else if (o instanceof Boolean){
		v[i] = new Variant(((Boolean)o).booleanValue());
	    } else if (o instanceof String){
		v[i] = new Variant((String)o);
	    } else {
		v[i] = new Variant(o);
	    }
	}
	return v;
    }

    public Object invoke(String name, Object args[]){
        Object o = Dispatch.invokev(disp, name, 1, makearray(args), null);
	if (o instanceof Variant){
	    return ComObject.getVariantValue((Variant)o);
	} else {
	    return o;
	}
    }
}
