/*
 * @(#) ComObject.java	1.2 99/03/30
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.ole;

import pnuts.lang.AbstractData;
import com.ms.activeX.*;
import com.ms.com.*;
import com.ms.lang.*;

public class ComObject implements AbstractData {

    ActiveXControl ax;

    public ComObject(){}

    public ComObject(ActiveXControl control){
	this.ax = control;
    }

    public ComObject(String guid){
	ax = new ActiveXControl(guid);
    }

    public void set(String name, Object value){
	if (value instanceof Variant){
	    ax.setProperty(name, (Variant)value);
	} else if (value instanceof Number){
	    if (value instanceof Integer){
		ax.setProperty(name, new Variant(((Integer)value).intValue()));
	    } else if (value instanceof Double){
		ax.setProperty(name, new Variant(((Double)value).doubleValue()));
	    } else {
		ax.setProperty(name, new Variant(value));
	    }
	} else if (value instanceof String){
	    ax.setProperty(name, (String)value);
	} else if (value instanceof Boolean){
	    ax.setProperty(name, ((Boolean)value).booleanValue());
	} else {
	    ax.setProperty(name, new Variant(value));
	}
    }

    public Object get(String name){
	Variant v = ax.getProperty(name);
	return getVariantValue(v);
    }

    public Object invoke(String name, Object args[]){
	Object o = Dispatch.invoke(ax.getObject(), name, 2, ComDispatch.makearray(args), new int[1]);
	if (o instanceof Variant){
	     return getVariantValue((Variant)o);
	} else {
	    return o;
	}
    }

    static Object getVariantValue(Variant v){
	int i = v.getvt();
	switch (i){
	case Variant.VariantNull:
	    return null;
	case Variant.VariantShort:
	    return new Short(v.toShort());
	case Variant.VariantInt:
	    return new Integer(v.toInt());
	case Variant.VariantFloat:
	    return new Float(v.toFloat());
	case Variant.VariantDouble:
	    return new Double(v.toDouble());
	case Variant.VariantCurrency:
	    return new Double(v.toDouble());
	case Variant.VariantString:
	    return v.toString();
	case Variant.VariantDispatch:
	    return new ComDispatch(v.toDispatch());
	case Variant.VariantBoolean:
	    return new Boolean(v.toBoolean());
	case Variant.VariantByte:
	    return new Byte(v.toByte());
	case Variant.VariantObject:
	    return v.toObject();
	default:
	    return v;
	}
    }
}
