#
# %W% %E%
#
# Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software
# and its documentation for NON-COMMERCIAL purposes and without
# fee is hereby granted provided that this copyright notice
# appears in all copies. Please refer to the file "copyright.html"
# for further important copyright and licensing information.
#
# SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
# THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
# TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
# ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
# DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
#

#
# for GNU make
#
ALLFILES.java = $(shell /bin/find . -name '*.java' -print -o -name 'SCCS' -prune -o -name 'tmp' -prune | sed -e 's/^.\///'; true)

#
# for Solaris make
#
ALLFILES.java:sh = /bin/find . -name '*.java' -print -o -name 'SCCS' -prune  -o -name 'tmp' -prune | sed -e 's/^.\///'; true

ALLFILES.class = $(ALLFILES.java:%.java=%.class)

FILES.class = $(FILES.java:%.java=$(CLASSDIR)/%.class)

everything : compile.allclasses
everything.win32 : compile.allclasses.win32

compile.allclasses: $(CLASSDIR) .delete.classlist $(JJFILES) $(ALLFILES.class:%=$(CLASSDIR)/%) .compile.classlist

compile.allclasses.win32: $(CLASSDIR) .delete.classlist $(JJFILES) $(ALLFILES.class:%=$(CLASSDIR)/%) .compile.classlist.win32

compile.classes: $(CLASSDIR) .delete.classlist $(FILES.class) .compile.classlist

.delete.classlist:
	@/bin/rm -f .classes.list

.compile.classlist: 
	@if [ -s .classes.list ] ; then \
	    echo $(JAVAC) -d $(CLASSDIR) \
	    $(JAVACFLAGS) \
	    `cat .classes.list` ; \
	    $(JAVAC) -d $(CLASSDIR) \
	    $(JAVACFLAGS) \
	    `cat .classes.list` ; \
	fi

.compile.classlist.win32:
	@if [ -s .classes.list ] ; then \
	    echo $(JAVAC) -d $(CLASSDIR) \
	    $(JAVACFLAGS) \
	    `sed 's/\\//\\\\/g' .classes.list` ; \
	    $(JAVAC) -d $(CLASSDIR) \
	    $(JAVACFLAGS) \
	    `sed 's/\\//\\\\/g' .classes.list` ; \
	fi

$(CLASSDIR):
	@mkdir -p $@

JJFILES = $(SRCDIR)/pnuts/lang/Pnuts.jj

$(SRCDIR)/%.jj: $(SRCDIR)/%.jjt
	@cd `dirname $<` ;\
	jjtree `/bin/basename $<`

$(SRCDIR)/%Parser.java: $(SRCDIR)/%.jj
	@cd `dirname $<` ;\
	javacc `/bin/basename $<`

$(CLASSDIR)/%.class: $(SRCDIR)/%.java
	@echo $< >>.classes.list

#jar:
#	rm -f $(PWD)/$(JAR)
#	cd $(CLASSDIR); jar cfM $(PWD)/$(JAR) $(ALLFILES.class) $(STUBS) $(SKELTONS) $(RESOURCES)
#

clean:
	rm -rf $(CLASSDIR) .classes*

doc: FORCE
	@mkdir -p $(DOCDIR)
	javadoc $(JAVADOC_FLAGS) -d $(DOCDIR) -classpath ./classes:$(CLASSPATH) -sourcepath .:$(JAVA_SRC) $(PACKAGES)

FORCE:
