/*
 * @(#) CardLayoutMapping.java	1.3 98/09/04
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.awt;
import java.awt.*;

/**
 * CardLayout mapping of <a href="/pnuts/doc/hierarchicalLayout.html">Hierarchical Layout</a>.
 *
 * @version	1.3
 * @author	Toyokazu Tomatsu
 */
public class CardLayoutMapping extends Layout {

    public Container createContainer(Container container, Object[] format){
	Object args[] = (Object[])format[1];
	CardLayout lm = null;
	if (args.length == 0){
	    lm = new CardLayout();
	} else if (args.length == 2){
	    lm = new CardLayout(((Integer)args[0]).intValue(), ((Integer)args[1]).intValue());
	}
	container.setLayout(lm);
	for (int i = 2; i < format.length; i++){
	    Object[] a = (Object[])format[i];
	    if (a[1] == null){
		container.add((String)a[0], makePanel(container));
	    } else if (isArray(a[1])){
		container.add((String)a[0], Layout.layout(makePanel(container), (Object[])a[1]));
	    } else {
		container.add((String)a[0], (Component)a[1]);
	    }
	}
	return container;
    }
}
