/*
 * @(#) FlowLayoutMapping.java	1.3 98/09/04
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.awt;

import java.awt.*;

/**
 * FlowLayout mapping of <a href="/pnuts/doc/hierarchicalLayout.html">Hierarchical Layout</a>.
 *
 * @version	1.3
 * @author	Toyokazu Tomatsu
 */
public class FlowLayoutMapping extends Layout {

    public Container createContainer(Container container, Object[] format){
	Object args[] = (Object[])format[1];
	FlowLayout lm = null;
	if (args.length == 0){
	    lm = new FlowLayout();
	} else if (args.length == 1){
	    lm = new FlowLayout(((Integer)args[0]).intValue());
	} else if (args.length == 3){
	    lm = new FlowLayout(((Integer)args[0]).intValue(),
				((Integer)args[1]).intValue(),
				((Integer)args[2]).intValue());
	}
	container.setLayout(lm);
	for (int i = 2; i < format.length; i++){
	    Object a = format[i];
	    if (a == null){
		container.add("", makePanel(container));
	    } else if (isArray(a)){
		container.add("", Layout.layout(makePanel(container), (Object[])a));
	    } else {
		container.add("", (Component)a);
	    }
	}
	return container;
    }
}
