/*
 * @(#) GridBagLayoutMapping.java	1.3 98/09/04
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.awt;

import java.awt.*;
import java.util.*;

/**
 * GridBagLayout mapping of <a href="/pnuts/doc/hierarchicalLayout.html">Hierarchical Layout</a>.
 *
 * @version	1.3
 * @author	Toyokazu Tomatsu
 */
public class GridBagLayoutMapping extends Layout {

    public Container createContainer(Container container, Object[] format){
	GridBagLayout lm = new GridBagLayout();
	container.setLayout(lm);

	for (int i = 1; i < format.length; i++){
	    GridBagConstraints c = new GridBagConstraints();
	    Object a[] = (Object[])format[i];
	    Hashtable table = PnutsLayout.str2table((String)a[0]);
	    String g;
	    if ((g = (String)table.get("gridx")) != null){
		c.gridx = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("gridy")) != null){
		c.gridy = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("gridwidth")) != null){
		c.gridwidth = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("gridheight")) != null){
		c.gridheight = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("weightx")) != null){
		c.weightx = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("weighty")) != null){
		c.weighty = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("anchor")) != null){
		try {
		    c.anchor = ((Integer)GridBagConstraints.class.getField(g).get(null)).intValue();
		} catch (Exception e){}
	    }
	    if ((g = (String)table.get("fill")) != null){
		try {
		    c.fill = ((Integer)GridBagConstraints.class.getField(g).get(null)).intValue();
		} catch (Exception e){}
	    }
	    if ((g = (String)table.get("insets")) != null){
		StringTokenizer st = new StringTokenizer(g, ":");
		c.insets = new Insets(Integer.parseInt(st.nextToken()),
				      Integer.parseInt(st.nextToken()),
				      Integer.parseInt(st.nextToken()),
				      Integer.parseInt(st.nextToken()));
	    }
	    if ((g = (String)table.get("ipadx")) != null){
		c.ipadx = Integer.parseInt(g);
	    }
	    if ((g = (String)table.get("ipady")) != null){
		c.ipady = Integer.parseInt(g);
	    }
	    Component comp = null;
	    if (a[1] instanceof Object[]){
		comp = Layout.layout(makePanel(container), (Object[])a[1]);
	    } else {
		comp = (Component)a[1];
	    }
	    lm.setConstraints(comp, c);
	    container.add(comp);
	}
	return container;
    }
}
