/*
 * @(#) IPnutsProxy.java	1.1 99/03/30
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.ext;

import java.io.InputStream;
import java.io.Reader;
import java.io.FileNotFoundException;
import pnuts.lang.Pnuts;
import pnuts.lang.PnutsFunction;
import pnuts.lang.Context;

/**
 * This interface is used as an instance variable of PnutsClient.
 *
 * @version	1.1
 * @see		pnuts.ext.PnutsClient
 * @see		pnuts.ext.PnutsProxy
 */
public interface IPnutsProxy {

    /**
     * @see pnuts.lang.Pnuts#eval(String, pnuts.lang.Context)
     */
    public Object eval(String str, Context context);

    /**
     * @see pnuts.lang.Pnuts#loadFile(String, pnuts.lang.Context)
     */
    public Object loadFile(String file, Context context) throws FileNotFoundException;

    /**
     * @see pnuts.lang.Pnuts#load(String, pnuts.lang.Context)
     */
    public Object load(String file, Context context) throws FileNotFoundException;

    /**
     * @see pnuts.lang.Pnuts#load(InputStream, pnuts.lang.Context)
     */
    public Object load(InputStream in, Context context);

    /**
     * @see pnuts.lang.Pnuts#load(Reader, pnuts.lang.Context)
     */
    public Object load(Reader in, Context context);

    /**
     * @see pnuts.lang.Pnuts#run(pnuts.lang.Context)
     */
    public Object run(Pnuts pnuts, Context context);

    /**
     * @see pnuts.lang.PnutsFunction#call(String, Object[], pnuts.lang.Context)
     */
    public Object call(String name, Object[] args, Context context);

    /**
     * @see pnuts.lang.PnutsFunction#call(Object[], pnuts.lang.Context)
     */
    public Object call(PnutsFunction func, Object[] args, Context context);
}
