/*
 * @(#) PnutsProxy.java	1.2 99/03/30
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.ext;

import java.io.InputStream;
import java.io.Reader;
import java.io.FileNotFoundException;
import pnuts.lang.Pnuts;
import pnuts.lang.PnutsFunction;
import pnuts.lang.Context;

/**
 * This class provides a concrete implementation of IPnutsProxy.
 *
 * @version	1.2
 * @see		pnuts.ext.IPnutsProxy
 * @see		pnuts.ext.PnutsClient
 */
final
public class PnutsProxy implements IPnutsProxy {

    /**
     * @see pnuts.lang.Pnuts#eval(String, pnuts.lang.Context)
     */
    public Object eval(String str, Context context){
	return Pnuts.eval(str, context);
    }

    /**
     * @see pnuts.lang.Pnuts#loadFile(String, pnuts.lang.Context)
     */
    public Object loadFile(String file, Context context) throws FileNotFoundException {
	return Pnuts.loadFile(file, context);
    }

    /**
     * @see pnuts.lang.Pnuts#load(String, pnuts.lang.Context)
     */
    public Object load(String file, Context context) throws FileNotFoundException {
	return Pnuts.load(file, context);
    }

    /**
     * @see pnuts.lang.Pnuts#load(InputStream, pnuts.lang.Context)
     */
    public Object load(InputStream in, Context context) {
	return Pnuts.load(in, context);
    }

    /**
     * @see pnuts.lang.Pnuts#load(Reader, pnuts.lang.Context)
     */
    public Object load(Reader in, Context context) {
	return Pnuts.load(in, context);
    }

    /**
     * @see pnuts.lang.Pnuts#run(pnuts.lang.Context)
     */
    public Object run(Pnuts pnuts, Context context){
	return pnuts.run(context);
    }

    /**
     * @see pnuts.lang.PnutsFunction#call(String, Object[], pnuts.lang.Context)
     */
    public Object call(String name, Object[] args, Context context){
	return PnutsFunction.call(name, args, context);
    }

    /**
     * @see pnuts.lang.PnutsFunction#call(Object[], pnuts.lang.Context)
     */
    public Object call(PnutsFunction func, Object[] args, Context context){
	return func.call(args, context);
    }
}
