/*
 * @(#) Binding.java	1.2 99/06/02
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

import java.io.Serializable;
import java.io.ObjectInputStream;
import java.io.IOException;

/**
 * This class represents a name-value pair of SymbolTable.
 * Binding objects with a same hash code are linked succesively.
 *
 * @version	1.2
 * @see	pnuts.lang.SymbolTable
 */
class Binding implements Value, Serializable {

    /**
     * The name of the symbol
     */
    String name;

    /**
     * The value
     */
    Object value;

    /**
     * link
     */
    Binding chain;

    Binding(){
    }

    Binding(String name, Object value){
	this.name = name;
	this.value = value;
    }
    
    /**
     * Set a value
     */
    public void set(Object value){
	this.value = value;
    }

    /**
     * Get the value
     */
    public Object get(){
	return value;
    }

    private synchronized void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException {
	s.defaultReadObject();
	name = name.intern();
    }
}
