/*
 * @(#) Import.java	1.10 99/03/30
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

import java.io.Serializable;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.util.Hashtable;

class Import implements Serializable {

    static final long serialVersionUID = -4356750587373239877L;

    /**
     * @serial
     */
    String name;

    transient Hashtable table;

    public Import(String name){
	this.name = name;
	this.table = new Hashtable(64);
    }

    public String getName(){
	return name;
    }

    public Class get(String className){
	Class c = (Class)table.get(className);
	if (c != null){
	    return c;
	}
	String fullName = className;
	try {
	    Class clazz = null;
	    if (name.length() > 0){
		fullName = name + "." + className;
	    }

	    clazz = Pnuts.loadClass(fullName);
	    if (clazz != null){
		table.put(className, clazz);
	    }
	    return clazz;
	} catch (ClassNotFoundException e){
//	    if (Pnuts.debug()){
//		System.out.println(fullName + " class not found");
//	    }
	}
	return null;
    }

    private synchronized void readObject(ObjectInputStream s)
         throws IOException, ClassNotFoundException
    {
	s.defaultReadObject();
	table = new Hashtable(64);
    }

    public String toString(){
	return "import " + name;
    }
}
