/*
 * @(#) ManualContext.java	1.1 99/05/21
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

/**
 * This class represents a runtime context of the interpretation.
 * When an exception is thrown during an evaluation with ManualContext,
 * the exception is not caught by the interpreter and thrown out of
 * the static method call of pnuts.lang.Pnuts class.
 *
 * <pre>in Java:
 *   try {
 *      Pnuts.load(stream new ManualContext());
 *   } catch (PnutsException e){
 *      Throwable t = e.getThrowable();
 *      ...
 *   }
 * </pre>
 *
 * @version	1.1
 * @since	Pnuts 1.0beta3
 */
public class ManualContext extends Context {

    public ManualContext(){
    }

    public ManualContext(String pkg){
	super(pkg);
    }

    public ManualContext(Package pkg){
	super(pkg);
    }
}
