/*
 * @(#) Privileged.java	1.3 99/06/04
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

import java.security.AccessController;
import java.security.PrivilegedAction;
import java.io.InputStream;
import java.lang.reflect.Method;

class Privileged extends SecuritySensitive {

    String _getProperty(final String key){
	return (String)AccessController.doPrivileged(new PrivilegedAction(){
	    public Object run(){
		return System.getProperty(key);
	    }
	});
    }

    InputStream _getResourceAsStream(final String s){
	return (InputStream)AccessController.doPrivileged(new PrivilegedAction(){
	    public Object run(){
		ClassLoader cl = null;
		String res = s;
		try {
		    cl = ClassLoader.getSystemClassLoader();
		} catch (SecurityException t){/* skip */}
		if (cl != null){
		    if (s.startsWith("/")){
			res = s.substring(1);
		    }
		    return cl.getResourceAsStream(res);
		}
		return Pnuts.class.getResourceAsStream(res);
	    }
	});
    }

    Method[] _getMethods(final Class c){
	return (Method[])AccessController.doPrivileged(new PrivilegedAction(){
	    public Object run(){
		return c.getMethods();
	    }
	});
    }
}
