/*
 * @(#) Property.java	1.3 99/02/08
 *
 * Copyright (c) 1997,1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

/**
 * In Pnuts, access to a property of an object implements this interface
 * causes a call of methods in this interface.
 * See <a href="/pnuts/doc/lang.html#sugar">Pnuts Language Specification</a>
 * for details.
 *
 * @version	1.3
 * @author 	Toyokazu Tomatsu
 */
public interface Property {
    /**
     * This method defines the behavior of the following expression.
     * <pre>
     *    <em>aProperty</em> . <em>name</em> = <em>value</em>
     * </pre>
     */
    void set(String name, Object value);

    /**
     * This method defines the behavior of the following expression.
     * <pre>
     *    <em>aProperty</em> . <em>name</em>
     * </pre>
     */
    Object get(String name);
}
