/*
 * @(#) SecuritySensitive.java	1.2 99/05/21
 *
 * Copyright (c) 1997-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * See the file "license.txt" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

import java.lang.reflect.*;
import java.io.*;
import pnuts.lang.*;

class SecuritySensitive {

    static SecuritySensitive ss;
    static void init(){
	if (ss == null){
	    if (Pnuts.isJava2()){
		try {
		    Class clazz = Class.forName("pnuts.lang.Privileged");
		    ss = (SecuritySensitive)clazz.newInstance();
		} catch (ClassNotFoundException e1){
		} catch (IllegalAccessException e2){
		} catch (InstantiationException e3){
		}
	    } else {
		ss = new SecuritySensitive();
	    }
	}
    }
    static {
	init();
    }
    
    String _getProperty(String key){
	return System.getProperty(key);
    }

    static String getProperty(String key){
	return ss._getProperty(key);
    }

    InputStream _getResourceAsStream(String s){
	return Pnuts.class.getResourceAsStream(s);
    }

    static InputStream getResourceAsStream(String s){
	return ss._getResourceAsStream(s);
    }

    Method[] _getMethods(Class c){
	return c.getMethods();
    }

    static Method[] getMethods(Class c){
	return ss._getMethods(c);
    }
}
